//codul pentru masina
#include <SPI.h>
#include <nRF24L01.h>
#include <RF24.h>
//en urile reprezinta efectiv "motorul" iar cu in -urile controlez sensul motorului
#define enA 2  
#define in1 3
#define in2 4
#define enB 7   
#define in3 5
#define in4 6
RF24 radio(8, 9);
const byte address[6] = "00001";
char receivedData[32] = "";
int  x, y;
int viteza_motor_A = 0;
int viteza_motor_B = 0;
void setup() {
  pinMode(enA, OUTPUT);
  pinMode(enB, OUTPUT);
  pinMode(in1, OUTPUT);
  pinMode(in2, OUTPUT);
  pinMode(in3, OUTPUT);
  pinMode(in4, OUTPUT);
  Serial.begin(9600);
  radio.begin();
  radio.openReadingPipe(0, address);
  radio.setPALevel(RF24_PA_MIN);
  radio.startListening();
}
void loop() {
  if (radio.available()) {   // Daca se primeste date de la modulul bluettooth NRF240L01 
    radio.read(&receivedData, sizeof(receivedData)); // citesc array ul de date asa cum il trimit de la joystick
    x = atoi(&receivedData[0]); // Convertesc la int
    //Serial.print("x = ");
    //Serial.println(xAxis);
    //delay(1000);
    delay(10);
    radio.read(&receivedData, sizeof(receivedData));//la fel si pt axa y
    y = atoi(&receivedData[0]);
    //Serial.print("y = ");
    //Serial.println(yAxis);
    //delay(1000);
    delay(10);
  }
  //dupa care urmeaza sa fac verificarile in functie de cele doua axe
  //pe axa y e va misca fata spate iar pe x stanga dreapta
 
  if (y < 470) {
    // daca e in spate setes inputurile sa mearga in spate
    digitalWrite(in1, HIGH);
    digitalWrite(in2, LOW);
    
    digitalWrite(in3, HIGH);
    digitalWrite(in4, LOW);
    
    //dupa care cum pot sa dau o valoare pt motorspeed de la 0 la 255 ca sa nu mai fac nicio formul pentru PWM ma folsoesc de map
    //care ce face de fapt e sa imi spuna ce valoare reprezentativa am eu pe scaran de la 0 la 470 in scara d ela 0 la 255
    viteza_motor_A = map(y, 470, 0, 0, 255);
    viteza_motor_B = map(y, 470, 0, 0, 255);
  }
  else if (y > 550) {
    // daca se merge in fata
    digitalWrite(in1, LOW);
    digitalWrite(in2, HIGH);
    
    digitalWrite(in3, LOW);
    digitalWrite(in4, HIGH);
   
    viteza_motor_A = map(y, 550, 1023, 0, 255);
    viteza_motor_B = map(y, 550, 1023, 0, 255);
  }
  //daca se sta in intervalul[470,55] nu se va face nimic pe axa y
  else {
    viteza_motor_A = 0;
    viteza_motor_B = 0;
  }
  // pe axa x se vor face virajele
  if (x < 470) {
    // PWM 
    int xMapped = map(x, 470, 0, 0, 255);
    // Se face miscarea spre stanga adica se mareste viteza motorului a si se scade din vietza motorului b
    viteza_motor_A = viteza_motor_A + xMapped;
    viteza_motor_B = viteza_motor_B - xMapped;
    if (viteza_motor_A < 0) {
      viteza_motor_A = 0;
    }
    if (viteza_motor_B > 255) {
      viteza_motor_B = 255;
    }
  }
  if (x > 550) {
    //analog pentru virajul la dreapta
    int xMapped = map(x, 550, 1023, 0, 255);
    
    viteza_motor_A = viteza_motor_A - xMapped;
    viteza_motor_B = viteza_motor_B + xMapped;
    if (viteza_motor_A > 255) {
      viteza_motor_A = 255;
    }
    if (viteza_motor_B < 0) {
      viteza_motor_B = 0;
    }
  }
  //aici am observat ca daca se primeste ca viteza o val mai mica de 70 motorul nu face nimic..nu are putere asa ca il opresc definitiv
  if (viteza_motor_A < 70) {
    viteza_motor_A = 0;
  }
  if (viteza_motor_B < 70) {
    viteza_motor_B = 0;
  }
  //in final voi trimite semnalele
  analogWrite(enA, viteza_motor_A); 
  analogWrite(enB, viteza_motor_B); 
}
